<?php
/**
 * $Horde: nic/dns.php,v 1.17 2006/01/01 21:11:32 jan Exp $
 *
 * Copyright 2002-2006 Florian Clever <fc@clever-soft.com>
 *
 * See the enclosed file COPYING for license information (LGPL). If you
 * did not receive this file, see http://www.fsf.org/copyleft/lgpl.html.
 */

@define('NIC_BASE', dirname(__FILE__));
require NIC_BASE . '/lib/base.php';

$title = Nic::getServiceName('dns');
require NIC_TEMPLATES . '/common-header.inc';
require NIC_TEMPLATES . '/menu.inc';

$addr = escapeshellcmd(trim(Util::getFormData('addr')));
$type = Util::getFormData('type');

// check if the address is an IP:
if (preg_match('/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/', $addr)) {
    $addr = gethostbyaddr($addr);
}

if (!empty($addr)) {
    include_once 'Net/DNS.php';
    $res = &new Net_DNS_Resolver();
    $res->nameservers = array($GLOBALS['conf']['server']['dns']);
    $packet = $res->search($addr, $type);
    if (!is_object($packet)) {
        $dnsArray = array(_("Lookup Failed"));
    } else {
        $dnsArray = explode("\n", $packet->string());
    }

    // Store the resulting output in $results, which is output by the
    // dns.inc template.
    $results = implode("\n<br />", $dnsArray);
}

require NIC_TEMPLATES . '/dns/dns.inc';
require $registry->get('templates', 'horde') . '/common-footer.inc';
