<?php
/**
 * $Horde: nic/lib/Whois.php,v 1.4 2005/02/03 20:13:59 chuck Exp $
 */

// Whois servers.
@define('NICHOST',       'whois.crsnic.net');
@define('INICHOST',      'whois.networksolutions.com');
@define('DNICHOST',      'whois.nic.mil');
@define('GNICHOST',      'whois.nic.gov');
@define('ANICHOST',      'whois.arin.net');
@define('RNICHOST',      'whois.ripe.net');
@define('PNICHOST',      'whois.apnic.net');
@define('RUNICHOST',     'whois.ripn.net');
@define('MNICHOST',      'whois.ra.net');
@define('QNICHOST_TAIL', '.whois-servers.net');
@define('SNICHOST',      'whois.6bone.net');
@define('BNICHOST',      'whois.registro.br');

function whois($address)
{
    if (strstr($address, '@')) {
        list($domaine, $server) = explode('@', $address);
    } else {
        $domaine = $address;
        $server = choose_server($domaine);
        if (!strstr($server, '.')) {
            return array("Error", $server);
        }
    }
    $datas = '';
    do {
        $loop = 0;
        $data = do_whois($domaine, $server);
        $datas .= "\n" . $data;
        if (preg_match("/Whois Server: (.*?)\n/", $data, $match)) {
            $loop = 1;
            $server = $match[1];
        } else {
            if (strstr($data, ANICHOST)) {
                $server = ANICHOST;
                $loop = 1;
            } elseif (strstr($data, RNICHOST)) {
                $server = RNICHOST;
                $loop = 1;
            } elseif (strstr($data, PNICHOST)) {
                $server = PNICHOST;
                $loop = 1;
            }
        }
    } while ($loop == 1);
    return $datas;
}

function choose_server($domaine)
{
    preg_match('/\.([^.]*)$/', $domaine, $match);
    if (empty($match[1])) {
        return 'Invalid Domain';
    }
    if ($match[1] > 0) {
        return ANICHOST;
    } else {
        return $match[1] . QNICHOST_TAIL;
    }
}

function do_whois($domaine, $server)
{
    require_once 'Net/Socket.php';
    $whoisd = &new Net_Socket();
    if (!$whoisd->connect($server, getservbyname('whois', 'tcp'))) {
        return 'whois Socket Error: ' . $whoisd->error();
    }

    $whoisd->writeLine($domaine);
    $data = $whoisd->readAll();
    $whoisd->disconnect();

    if (is_a($data, 'PEAR_Error')) {
        return $data->getMessage();
    } else {
        return $data;
    }
}
