<?php
/**
 * $Horde: nic/mailaddrcheck.php,v 1.23 2006/01/01 21:11:32 jan Exp $
 *
 * Copyright 2000-2006 Charles J. Hagenbuch, <chuck@horde.org>
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/asl.php.
 */

@define('NIC_BASE', dirname(__FILE__));
require_once NIC_BASE . '/lib/base.php';

$title = Nic::getServiceName('mailaddrcheck');
require NIC_TEMPLATES . '/common-header.inc';
require NIC_TEMPLATES . '/menu.inc';

$email_address = Util::getFormData('email_address');
$Checkmethod = 'default';
if (!empty($email_address)) {
    list($username, $maildomain) = explode('@', $email_address);
    /* Get real mailserver's address from its MX record. */
    $mxhosts = array();
    $mxpriorities = array();
    if (!OS_WINDOWS) {
        if (getmxrr($maildomain, $mxhosts, $mxpriorities)) {
            // MX record found, use it and tell the user about it too.
            array_multisort($mxpriorities, $mxhosts);
            $mailhost = $mxhosts[0];
            $Checkmethod = 'Mail Exchanger';
        } else {
            // No MX record found, lets try the root domain host as the mail server.
            $mailhost = $maildomain;
            $Checkmethod = 'Domain Root Host';
        }
    } else {
        // May not work, but it's what we can do for now.
        $mailhost = $maildomain;
        $Checkmethod = 'Domain Root Host (forced)';
    }

    /* Do the test */
    $errno = 0;
    $errstr = '';
    $fp = @fsockopen($mailhost, 25, $errno, $errstr);
    if (!$fp) {
        /* No connection established */
        $result = "$errstr ($errno)";
        $result .= "<br />Checked using $Checkmethod Record";
    } else {
        /* Show the results */
        $response = fgets($fp, 4096);
        $result = "Checked using $Checkmethod Record<br /><br />";
        $result .= "$response<br />\n";

        $result .= "HELO $mailhost<br />\n";
        fputs($fp, "HELO $mailhost\r\n");
        $response = fgets($fp, 4096);
        $result .= "$response<br />\n";

        $result .= 'MAIL FROM: &lt;' . $_SERVER['SERVER_ADMIN'] . "&gt;<br />\n";
        fputs($fp, 'MAIL FROM: <' . $_SERVER['SERVER_ADMIN'] . ">\r\n");
        $response = fgets($fp, 4096);
        $result .= "$response<br />\n";

        $result .= "RCPT TO: &lt;$email_address&gt;<br />\n";
        fputs($fp, "RCPT TO: <$email_address>\r\n");
        $response = trim(fgets($fp, 4096));
        $result .= "$response<br />\n";

        if (substr($response, 0, 1) == '2') {
            $eMailResultShort = '<font color="green">VALID</font>';
            $eMailResult = "$mailhost responded with: $response. $email_address seems to be valid.";
        } else {
            $eMailResultShort = '<font color="red">INVALID</font>';
            $eMailResult = "$mailhost responded with: $response<br />which would indicate that $email_address may not be a valid address." ;
        }

        $result .= "QUIT<br />\n";
        fputs($fp, "QUIT\r\n");
        $response = fgets($fp, 4096);
        $result .= "$response<br />\n";

        fclose($fp);

        $result .= "<br /><strong>Result: $eMailResultShort</strong><br />$eMailResult\n";
     }
}

require NIC_TEMPLATES . '/mailaddrcheck/mailaddrcheck.inc';
require $registry->get('templates', 'horde') . '/common-footer.inc';
