<?php
/**
 * $Horde: nic/ping.php,v 1.29 2006/01/01 21:11:32 jan Exp $
 *
 * Copyright 2000-2006 Charles J. Hagenbuch, <chuck@horde.org>
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/asl.php.
 */

@define('NIC_BASE', dirname(__FILE__));
require_once NIC_BASE . '/lib/base.php';

$title = Nic::getServiceName('ping');
require NIC_TEMPLATES . '/common-header.inc';
require NIC_TEMPLATES . '/menu.inc';

$results = '';
if ($addr = Util::getFormData('addr')) {
    include_once 'Net/Ping.php';
    $ping = &Net_Ping::factory();

    // ping host and get response object
    if (is_a($ping, 'PEAR_Error')) {
        $results = $ping->getMessage();
    } else {
        // Set ping parameters.
        $ping->setArgs(array('count' => 5));

        // Start pinging.
        $response = @$ping->ping($addr);
        if (is_a($response, 'PEAR_Error')) {
            $results = $response->getMessage();
        } else {
            // Possible stats to output.
            /*
            $results = _("Round-trim time in ms") . '<br />';
            $results .= _("Minimum") . ': ' . $response->getMin() . '<br />';
            $results .= _("Maximum") . ': ' . $response->getMax() . '<br />';
            $results .= _("Average") . ': ' . $response->getAvg() . '<br />';
            $results .= '<br />';
            $results .= _("Packets transmitted") . ': ' . $response->getTransmitted() . '<br />';
            $results .= _("Packets received") . ': ' . $response->getReceived() . '<br />';
            $results .= _("Packets lost") . ': ' . $response->getLoss() . '<br />';
            $results .= '<br />';
            $results .= _("Bytes per request") . ': ' . $response->getBytesPerRequest() . '<br />';
            $results .= _("Total bytes") . ': ' . $response->getBytesTotal() . '<br />';
            $results .= '<br />';
            $results .= _("TTL") . ': ' . $response->getTTL() . '<br />';
            $results .= '<br />';
            $results .= _("Raw data") . ': ';
            */
            $results .= implode('<br />', $response->getRawData());
        }
    }
}

require NIC_TEMPLATES . '/ping/ping.inc';
require $registry->get('templates', 'horde') . '/common-footer.inc';
