<?php
/**
 * $Horde: nic/relay.php,v 1.26 2006/01/01 21:11:32 jan Exp $
 *
 * Copyright 2000-2006 Charles J. Hagenbuch, <chuck@horde.org>
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/asl.php.
 */

function _getResponse($command, &$result)
{
    global $fp;

    $result .= htmlspecialchars($command) . "<br />\n";
    fputs($fp, $command . "\n");
    $response = htmlspecialchars(fgets($fp, 4096));
    $result .= $response . "<br />\n";
    return $response;
}

@define('NIC_BASE', dirname(__FILE__));
require_once NIC_BASE . '/lib/base.php';

$title = Nic::getServiceName('relay');
require NIC_TEMPLATES . '/common-header.inc';
require NIC_TEMPLATES . '/menu.inc';

$MailHost = Util::getFormData('MailHost');

if (!empty($MailHost)) {
    /* Do the test */
    $errno = 0;
    $errstr = '';
    $fp = @fsockopen($MailHost, 25, $errno, $errstr);
    if (!$fp) {
        /* No connection established */
        $result = String::convertCharset($errstr, 'ISO-8859-1') . " ($errno)";
    } else {
        /* Show the results */
        $response = fgets($fp, 4096);
        $result = "$response<br />\n";

        _getResponse('HELO mail.example.com', $result);
        _getResponse('MAIL FROM: <root@example.com>', $result);

        $response = _getResponse('RCPT TO: <root@example.com>', $result);
        if (substr($response, 0, 1) == '2') {
            $RelayAllowed = "The host $MailHost seems to be an open mail relay!: $response";
        } else {
            $RelayAllowed = $response;
        }

        _getResponse('QUIT', $result);

        fclose($fp);

        $result .= "<h4>Result:<br />$RelayAllowed</h4>\n";
    }
}

require NIC_TEMPLATES . '/relay/relay.inc';
require $registry->get('templates', 'horde') . '/common-footer.inc';
