<?php
/**
 * $Horde: nic/services.php,v 1.22 2006/01/01 21:11:32 jan Exp $
 *
 * Copyright 2000-2006 Charles J. Hagenbuch, <chuck@horde.org>
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/asl.php.
 */

// Services Status Script
// ----------------------
//
// Version 1.2
// [Freely distributable]
//
// HISTORY
// -------
// v1.0  First released

// v1.1  Moved $logerrors to an obvious place for editing (braindead alert!)

// v1.2  Fixed a bug where only one service could be specified per host
//
// Snippets of code from Sasha Dolgy [dolgys@psi.ca]
// Snippets of code from Rasmuf Lerdorf [rasmus@php.net]
//
// Author: Ollie Cook [o.cook@etoncollege.org.uk]

@define('NIC_BASE', dirname(__FILE__));
require_once NIC_BASE . '/lib/base.php';

$title = Nic::getServiceName('services');
require NIC_TEMPLATES . '/common-header.inc';
require NIC_TEMPLATES . '/menu.inc';

$results = '';
$hostsport = Util::getFormData('hostsport');
$FTP = Util::getFormData('ftp');
$SSH = Util::getFormData('ssh');
$TELNET = Util::getFormData('telnet');
$SMTP = Util::getFormData('smtp');
$GOPHER = Util::getFormData('gopher');
$FINGER = Util::getFormData('finger');
$HTTP = Util::getFormData('hTtp');
$POP3 = Util::getFormData('pop3');
$NNTP = Util::getFormData('nntp');
$IMAP = Util::getFormData('imap');
$HTTPS = Util::getFormData('https');
$SSMTP = Util::getFormData('ssmtp');
$SPOP3 = Util::getFormData('spop3');
$SIMAP = Util::getFormData('simap');
$ALLPORTS = Util::getFormData('all');

$portnames = array(
    21  => 'FTP',
    22  => 'SSH',
    23  => 'TELNET',
    25  => 'SMTP',
    70  => 'GOPHER',
    79  => 'FINGER',
    80  => 'HTTP',
    110 => 'POP3',
    119 => 'NNTP',
    143 => 'IMAP',
    443 => 'HTTPS',
    465 => 'SSMTP',
    993 => 'SIMAP',
    995 => 'SPOP3',
);
$logerrors = 1;

if (!empty($hostsport)) {
    $hostsname = preg_split("/[\s,]+/", $hostsport);
    $results = "<table><tr><td>Host</td><td>Service</td><td>Status</td>\n";
    while (list($key, $server) = each($hostsname)) {
        $i = 0;
        if ($ALLPORTS) {
            $port[$i++] = 21;
            $port[$i++] = 22;
            $port[$i++] = 23;
            $port[$i++] = 25;
            $port[$i++] = 70;
            $port[$i++] = 79;
            $port[$i++] = 80;
            $port[$i++] = 110;
            $port[$i++] = 119;
            $port[$i++] = 143;
            $port[$i++] = 443;
            $port[$i++] = 465;
            $port[$i++] = 993;
            $port[$i++] = 995;
        } else {
            if ($FTP) {
                $port[$i] = $FTP;
                $i++;
            }
            if ($SSH) {
                $port[$i] = $SSH;
                $i++;
            }
            if ($TELNET) {
                $port[$i] = $TELNET;
                $i++;
            }
            if ($SMTP) {
                $port[$i] = $SMTP;
                $i++;
            }
            if ($GOPHER) {
                $port[$i] = $GOPHER;
                $i++;
            }
            if ($FINGER) {
                $port[$i] = $FINGER;
                $i++;
            }
            if ($HTTP) {
                $port[$i] = $HTTP;
                $i++;
            }
            if ($POP3) {
                $port[$i] = $POP3;
                $i++;
            }
            if ($NNTP) {
                $port[$i] = $NNTP;
                $i++;
            }
            if ($IMAP) {
                $port[$i] = $IMAP;
                $i++;
            }
            if ($HTTPS) {
                $port[$i] = $HTTPS;
                $i++;
            }
            if ($SSMTP) {
                $port[$i] = $SSMTP;
                $i++;
            }
            if ($SPOP3) {
                $port[$i] = $SPOP3;
                $i++;
            }
            if ($SIMAP) {
                $port[$i] = $SIMAP;
                $i++;
            }
        }
        for ($j = 0; $j < $i; $j++) {
            $service = '';
            $service = $portnames[$port[$j]];
            if ($service == '') {
                $service = "UNKNOWN (port " . $port[$j] . ')';
            }
            $httpserver = @fsockopen($server, $port[$j], $errno, $errstr);
            if (!$httpserver) {
                if (isset($logerrors)) {
                    $results .="   <tr><td>$server</td><td>$service</td><td><font color=\"#ff0000\"><strong>DOWN</strong></font></td></tr>\n";
                }
            } else {
                $results .="   <tr><td>$server</td><td>$service</td><td><font color=\"#00cc00\"><strong>UP</strong></FONT></td></td>\n";
            }
        }
    }
    $results .= '</table>';
}

require NIC_TEMPLATES . '/services/services.inc';
require $registry->get('templates', 'horde') . '/common-footer.inc';
