<?php
/**
 * $Horde: nic/traceroute.php,v 1.24 2006/01/01 21:11:32 jan Exp $
 *
 * Copyright 2000-2006 Charles J. Hagenbuch, <chuck@horde.org>
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/asl.php.
 */

@define('NIC_BASE', dirname(__FILE__));
$session_control = 'readonly';
require_once NIC_BASE . '/lib/base.php';

$title = Nic::getServiceName('traceroute');
require NIC_TEMPLATES . '/common-header.inc';
require NIC_TEMPLATES . '/menu.inc';

$results = '';
if ($traceroute = Util::getFormData('traceroute')) {
    include_once 'Net/Traceroute.php';

    $tr = &Net_Traceroute::factory();
    if (is_a($tr, 'PEAR_Error')) {
        $results = $tr->getMessage();
    } else {
        $response = $tr->traceroute($traceroute);
        $results = '<table>';
        $results .= '<tr><th>' . _("Hop") . '</th><th>' . _("Time") . '</th><th>' . _("Time") . '</th><th>' . _("Time") . '</th><th>' . _("Host") . '</th><th>' . _("IP") . "</th></tr>\n";
        $hopCount = 1;

        // Get hop data as an array.
        $hops = $response->getHops();
        foreach ($hops as $h) {
            $results .= '<tr><td>' . $hopCount++ . '</td><td>' .
                (isset($h['responsetimes'][0]) ? $h['responsetimes'][0] : '') .
                '</td><td>' .
                (isset($h['responsetimes'][1]) ? $h['responsetimes'][1] : '') .
                '</td><td>' .
                (isset($h['responsetimes'][2]) ? $h['responsetimes'][2] : '') .
                '</td><td>' . (isset($h['machine']) ? $h['machine'] : '') .
                '</td><td>' . $h['ip'] . "</td></tr>\n";
            $hopCount++;
        }

        $results .= '</table>';
    }
}

require NIC_TEMPLATES . '/traceroute/traceroute.inc';
require $registry->get('templates', 'horde') . '/common-footer.inc';
